//---------------------------------------------------------------------------
//
//      SusievOCǗNX
//
//---------------------------------------------------------------------------
#ifndef spi_manage_h
#define spi_manage_h

#include "susie_plugin.h"
#include <vector>

#define SPI_FMASK_SSS    0x7
#define SPI_FMASK_I      0x80
#define SPI_FMASK_DDD    0x700
#define SPI_FLAG_I_SAME  0x80 //Ȃ񂾂킩񂼁H
#define SPI_FLAG_FILE    0
#define SPI_FLAG_MEM     1
#define SPI_FLAG_OUTFILE 0
#define SPI_FLAG_OUTMEM  0x100
#define IS_FILEIN(f) (((f) & SPI_FMASK_SSS) == SPI_FLAG_FILE)
#define IS_MEMIN(f) (((f) & SPI_FMASK_SSS) == SPI_FLAG_MEM)
//---------------------------------------------------------------------------
class Spi_manager
{
private:
    std::vector <Susie_plugin *> spiam_array;
    int spiam_count;
    std::vector <Susie_plugin *> spiin_array;
    int spiin_count;

public:
// Constructor
    Spi_manager()
    {
        spiin_count = 0;
        spiam_count = 0;
    }

// Destructor
    ~Spi_manager()
    {
        std::vector<Susie_plugin *>::iterator ite;
        if (!spiin_array.empty())
            for (ite = spiin_array.begin(); ite != spiin_array.end(); ite++) {
                delete *ite;
            }
        if (!spiam_array.empty())
            for (ite = spiam_array.begin(); ite != spiam_array.end(); ite++) {
                delete *ite;
            }
    }

    // vOC[h
    void __fastcall loadall(const char *path);
    // vOC[h
    bool __fastcall loadone(const char *path);
    // vOC̏𓾂
    AnsiString __fastcall spiinfonum(int num, int infono);
    // Ή`FbN
    Susie_plugin* __fastcall filecheck(char *src, char *mem);

    //pcspiNULL̏ꍇ̓t@C`FbN
    //vOCm肵ĂȂn
    //vOCNXւ̃|C^Ԃ悤ɂH
    bool __fastcall spi_info(Susie_plugin *pcspi, const int infono, const LPSTR buf, const int buflen);
    int __fastcall spi_picinfo(Susie_plugin *pcspi, const LPSTR buf, const long len,
                      const unsigned int flag, PictureInfo *lpInfo);
    int __fastcall spi_pic(Susie_plugin *pcspi, const LPSTR buf, const long len, const unsigned int flag,
                     HANDLE *pHBInfo, HANDLE *pHBm,
                   SPI_PROGRESS lpPrgressCallback, const long lData);
    int __fastcall spi_prev(Susie_plugin *pcspi, const LPSTR buf, const long len, const unsigned int flag,
                     HANDLE *pHBInfo, HANDLE *pHBm,
                   SPI_PROGRESS lpPrgressCallback, const long lData);
    int __fastcall spi_arcinfo(Susie_plugin *pcspi, const LPSTR buf, const long len,
                      const unsigned int flag, HLOCAL *lphInf);
    int __fastcall spi_fileinfo(Susie_plugin *pcspi, const LPSTR buf, const long len, const LPSTR filename,
                                 const unsigned int flag, fileInfo *lpInfo);
    int __fastcall spi_getfile(Susie_plugin *pcspi, const LPSTR src, const long len, const LPSTR dest, const unsigned int flag,
                        SPI_PROGRESS lpPrgressCallback, const long lData);
    bool __fastcall spi_confignum(const int num, const HWND parent, const int fnc);
    bool __fastcall spi_config(Susie_plugin *pcspi, const HWND parent, const int fnc);
    int __fastcall get_countam(void)
    {
        return spiam_count;
    }
    int __fastcall get_countin(void)
    {
        return spiin_count;
    }

    //xH
    int __fastcall spi2dib(const AnsiString &filename, HANDLE *pHBInfo, HANDLE *pHBm, HANDLE *pHfile, const bool preview);
    int __fastcall GetFileEx(const AnsiString &filename, const AnsiString &arcname, HANDLE *src, HANDLE *dest);
};

//extern Spi_manager *spi_man;

// **************************************************************
// ɉȂR[obN֐
//   R[obNw肵ȂƗvOĈ
// **************************************************************
static int __stdcall spi_null_callback(int nNum, int nDenom, long lData);


/*-------------------------------------------------------------------------*/
/* G[R[h                                                            */
/*-------------------------------------------------------------------------*/
#define SPI_FATAL_ERR         -2  /* vIG[iOj */

#endif /* spi_manage.h */
